function Permission (raw) {
	this.tokens = this.tokenize(raw);
}

// Does this permission allow the action given? The action is
// in the same format as permission strings.
//
// @param		String			action			The action
// @return		Boolean							True if action is allowed
Permission.prototype.allows = function (action) {
	var actionTokens = this.tokenize(action);
	var permissionTokens = this.tokens;
	var ok = false;
	for (var i = 0, len = permissionTokens.length; i < len; i++) {
		if (actionTokens[i]) {
			if (actionTokens[i] === permissionTokens[i]) {
				ok = true;
			} else if (permissionTokens[i] === '*') {
				ok = true;
			} else if (actionTokens[i] === '*') {
				ok = true;
			} else {
				ok = false;
				break;
			}
		} else {
			ok = false;
			break;
		}
	}
	return ok;
};

// Tokenize a string, returning the individual permission tokens.
//
// @param		String			str				The string
// @return		Array							The tokenized string
Permission.prototype.tokenize = function (str) {
	return str.toLowerCase().split('.');
};

module.exports = Permission;
