var Permission = require('./permission');

// Session permissions.
//
// @param		Array			permissions			The permissions
// @param		String			name				The session group name
function Permissions (permissions, name) {
	this.permissions = [];
	this.name = name;

	if (!Array.isArray(permissions)) permissions = [];

	for (var i = 0; i < permissions.length; i++) {
		var value = permissions[i];
		if (value instanceof Permission) {
			this.permissions.push(value);
		} else if (typeof value === 'string') {
			this.permissions.push(new Permission(value));
		} else if (value instanceof Permissions) {
			for (var k = 0; k < value.length; k++) {
				this.permisisons.push(value[k]);
			}
		} else {
			var error = new TypeError('PermissionsError');
			error.name = 'PERMISSION_INVALID';
			throw error;
		}
	}
}

// Get the session group name.
//
// @return		String								The session group name
Permissions.prototype.getName = function () {
	return this.name;
};

// Set the session group name.
//
// @param		String			name				The session group name
// @return		String								The session group name
Permissions.prototype.setName = function (name) {
	this.name = name;
	return this.name;
};

// Check if action is allowed.
//
// @param		String			action				The action to check for
// @return		Boolean								True if action is allowed
Permissions.prototype.allows = function (action) {
	for (var i = 0, len = this.permissions.length; i < len; i++) {
		if (this.permissions[i].allows(action)) {
			return true;
		}
	}
	return false;
};

module.exports = Permissions;
