var utils = {};

// Convert degree to radian.
//
// @param		Number			deg				The degree
// @return		Number							The radian
utils.deg2rad = function (deg) {
	return deg * Math.PI / 180;
};

// Get distance between two points in metres:
// http://www.movable-type.co.uk/scripts/latlong.html
//
// @param		Number			latitude1		The first latitude
// @param		Number			longitude1		The first longitude
// @param		Number			latitude2		The second latitude
// @param		Number			longitude2		The second longitud
utils.getDistance = function (latitude1, longitude1, latitude2, longitude2) {
	var radius = 6371;
	var deltaLatitude = utils.deg2rad(latitude2 - latitude1);
	var deltaLongitude = utils.deg2rad(longitude2 - longitude1);
	
	latitude1 = utils.deg2rad(latitude1);
	latitude2 = utils.deg2rad(latitude2);

	var a = Math.sin(deltaLatitude / 2) * Math.sin(deltaLatitude / 2) + Math.sin(deltaLongitude / 2) * Math.sin(deltaLongitude / 2) * Math.cos(latitude1) * Math.cos(latitude2); 
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a)); 
	var d = radius * c;

	return d * 1000;
};

module.exports = utils;
