var express = require('express');
var ejs = require('ejs');
var app = express();
var ETA = require('../../index');
var credentials = require('./credentials.json');

app.configure(function () {
	app.set('views', __dirname + '/views');
	app.engine('html', ejs.renderFile);
	app.use(express.cookieParser());
	app.use(express.cookieSession({
		secret: '#ateSWUSuFeXab3C$+ka',
		cookie: {
			maxAge: 1000 * 60 * 60 * 24 * 365
		}
	}));
	app.use(ETA.middleware({
		// Development app.
		apiKey: credentials.apiKey,
		apiSecret: credentials.apiSecret
	}));
	app.use(express.bodyParser());
	app.use(app.router);
});

app.get('/', ETA.requireAuth(null, ['api.users.*.read']), function (req, res) {
	res.render('signedin.html');
});
app.get('/signin', function (req, res) {
	res.render('signin.html');
});
app.post('/signin', function (req, res) {
	req.eta.taskQueues.createSession.invoke(function (err) {
		req.eta.session.attachUser(req.body, function (err) {
			if (!err) {
				res.redirect(req.eta.getPersistentData('etalastpage', '/'));
			} else {
				res.redirect('/signin');
			}
		});
	});
});
app.post('/signout', function (req, res) {
	req.eta.session.detachUser(function (err) {
		res.redirect('/');
	});
});

app.listen('8080');
